<template lang="">
    <div>
        <!--IF THIS BUTTON IS PRESSED...onProfileClick function is activated...
        see methods in export default-->
        <!--Using tracker as an index variable-->
        <h3 class="question-index">QUESTION {{tracker}}</h3>
        <div>
            <!--Looping through the questions data-->
            <li v-for="(question, index) in questions" :key="index">
                <!--showing only the current indexed element by comparing tracker index with current index-->
                <div ref='currentQuestion' v-show="tracker == index" :style="{height: (tracker == index) ? '100%': '0px'}">
                    <span>{{ question.question }}</span>
                    <span>
                    <ul>
                        <li>
                            <!--Retrieving value of the correct answer with a ref attribute-->
                            <button @click="onAnswerClick" ref="correct" v-bind:value="question.correct_answer">{{question.correct_answer}}</button>
                        </li>
                            
                        <li v-for="(questionOption, index) in question.incorrect_answers" :key="index">
                            <!--Clicking answers takes user to the next page with onAnswerClick-->
                            <button @click="onAnswerClick" v-bind:value="questionOption">{{questionOption}}</button>
                        </li>
                    </ul>
                    </span>
                </div>
            </li>
        </div>
    </div>
</template>
<script>

import { mapActions, mapState } from 'vuex'

export default {
    name: 'Question',
    data() {
        return {
            //used to track current index and adds
            //display logic with v-show
            tracker: 0,
        };
    },
    methods: {
        ...mapActions([ 'fetchQuestions',
                        'pushAnswer',
                        'pushCorrectAnswer',
                        'increaseScore' ]),
        onAnswerClick(event) {
            //push answer and correct answer to render
            //results page based with these arrays later
            this.pushAnswer(event.target.value)
            this.pushCorrectAnswer(this.$refs.correct[this.tracker].value)

            //If answer matches correct answer, increase score
            if (event.target.value === this.$refs.correct[this.tracker].value) {
                this.increaseScore()
            }

            //track the index of current question to 
            //view it dynamically, (see v-show logic)
            //inside of <template>
            this.tracker += 1
            if (this.tracker == this.questions.length) {
                this.$router.push('/result')
            }
        },
    },
    computed: {
        //getting the questions object from state
        ...mapState([ 'questions' ])
    },
    created() {
        //fetch questions once page has been created
        this.fetchQuestions()
    }
}


</script>


<!--adding scoped to limit CSS to this component only-->
<style scoped>

/* centering and styling the question components with flex */
.flex-container {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    flex-basis: 10rem;
}

</style>